"""
###################################################################
# BA_Conbagui_CaramelChocolateVanillaText.py Tutorial Scripted #
###################################################################
This script follows Conbagui's tutorial:
Caramel, Chocolate and Vanilla text tutorial as closely
as i could. 
=============================================================
This script should have received in a package containing:
=============================================================
Conbagui's Tutorial 
-----------------------------------------------------------------------------------------------------------
Caramel, Chocolate and Vanilla text.pdf
===========================================================================================================
4 gradients are used by the script that you must copy to your Gimp Gradients folder:
-----------------------------------------------------------------------------------------------------------
Caramel.ggr
Chocolate.ggr
Vanilla.ggr
Vanilla-2.ggr
===========================================================================================================
2 Fonts that are used in the tutorial that you must copy to your Gimp Fonts folder:
-----------------------------------------------------------------------------------------------------------
BRUSHSCI.TTF
TITANIA-REGULAR.TTF
===========================================================================================================
A Gimp .xcf file to open in Gimp before running the script contains
instruction/template and a completed example text layer.
-----------------------------------------------------------------------------------------------------------
BA_Conbagui_Caramel Chocolate Vanilla Text.xcf
===========================================================================================================
The python script to move to your Gimp plug-ins folder
-----------------------------------------------------------------------------------------------------------
BA_Conbagui_CaramelChocolateVanillaText.py
===========================================================================================================
And last, the instruction sheet
-----------------------------------------------------------------------------------------------------------
BA_Conbagui_CaramelChocolateVanillaText instructions.txt
===========================================================================================================
Open the BA_Conbagui_GoldBar_tutorial_template.xcf in gimp.  ##### <--- this blah blah has not been blah-blahed yet....
Follow the instructions for making your legend text on a     ##### <--- remember, keep your word and character count up! upupup! for gimp pointpointpoints
transparent layer of your creation.
Make sure that your text layer is at the top of the layer stack and 
that it is the active layer.
Run the script and you will receive your outcome.
You may then modify your legend text and re-run the script, 
or save the xcf with your legend text layer for later use.
===========================================================================================================
Hope that you enjoy the experience.
...................................................... 
####################
# COPYRIGHT NOTICE #
###############################################################################
# You should have received a copy of the GNU General Public License           #
# along with this program if not, you can view the GNU General Public         #
# License version 3 at the web site http://www.gnu.org/licenses/gpl-3.0.html  #
# Alternatively you can write to the Free Software Foundation, Inc., 675 Mass #
# Ave, Cambridge, MA 02139, USA.                                              #
###############################################################################
"""
#!/usr/bin/env python
from gimpfu import *

def BA_Conbagui_CaramelChocolateVanillaText(inImage,inDrawable,caramel,chocolate,vanilla,flatten):


####### check for correct size
    if inImage.width != 1600 or inImage.height != 900 :
        pdb.gimp_message('Background Image must be 1600 Width x 900 Height')
        return()        
####### set colors
    
####### Step 1   
    if caramel:
        pdb.gimp_context_push()
        black     ='#000000'
        caramelbg ='#120a00'
        caramelgr1='#a97537'
        caramelgr2='#d9b997'
        caramelbv1='#fbcf91'
        image = pdb.gimp_image_new(1600,900,RGB)
        frozen= pdb.gimp_image_undo_freeze(image)
        background=gimp.Image.new_layer(image)
        alpha=pdb.gimp_drawable_has_alpha(background)
        if not alpha:
            pdb.gimp_layer_add_alpha (background)
        background.name=('Background')
        pdb.gimp_context_set_background(caramelbg)
        pdb.gimp_edit_fill(background,BACKGROUND_FILL) 
        gradientlay=gimp.Image.new_layer(image)
        gradientlay.name='Layer'
        pdb.gimp_context_set_foreground(caramelgr1)
        pdb.gimp_edit_blend(gradientlay,FG_TRANSPARENT_MODE,NORMAL_MODE,GRADIENT_RADIAL,100,0.0,REPEAT_NONE,False,False,1,0,True,800,0,800,900)
        pdb.gimp_context_set_foreground(caramelgr1)
        pdb.gimp_edit_blend(gradientlay,FG_TRANSPARENT_MODE,NORMAL_MODE,GRADIENT_RADIAL,100,0.0,REPEAT_NONE,False,False,1,0,True,800,0,800,700)
        background = pdb.gimp_image_flatten(image)
        pdb.plug_in_gauss_rle2(image, background,400,400)
        pdb.plug_in_gauss_rle2(image, background,400,400)
####### get text
        caramel = pdb.gimp_layer_new_from_drawable(inDrawable,image) 
        image.add_layer(caramel)
        alpha=pdb.gimp_drawable_has_alpha(caramel)
        if not alpha:
            pdb.gimp_layer_add_alpha (caramel)
        caramel.name = 'Caramel'
        pdb.gimp_context_set_foreground('#b57111')      
        pdb.gimp_image_select_item(image,0,caramel)
        pdb.gimp_edit_fill(caramel,0) 
        pdb.gimp_selection_none(image)

        pdb.script_fu_layerfx_drop_shadow(image,caramel,black,75.0,0,0,2,0,9,130,5,1,0)
        pdb.script_fu_layerfx_bevel_emboss(image,caramel,1,65,0,9,16,130.0,45,5,caramelbv1,4,75,black,2,75,6,0,0)    
        pdb.script_fu_layerfx_gradient_overlay(image, caramel,'Caramel',0,0,0,100.0,5,800,450,90,900,0)
        caramel2 = pdb.gimp_layer_copy(caramel, 1)
        pdb.gimp_image_add_layer(image,caramel2,0)
        caramel2.name='Caramel copy'
        caramel2.mode=NORMAL_MODE
        pdb.gimp_item_set_visible(caramel2,False) 
        pdb.script_fu_layerfx_drop_shadow(image,caramel,black,45.0,0,0,2,0,5,120,5,0,0)
        pdb.script_fu_layerfx_bevel_emboss(image,caramel,1,65,0,18,5,130.0,45.0,5,black,4,100,'#633800',2,75,6,0,0) #black looks better
        visible = pdb.gimp_layer_new_from_visible(image,image,'visible')
        pdb.gimp_image_add_layer(image,visible,0)
        if flatten:
            background.name=('Caramel')
            pdb.gimp_image_flatten(image)
        pdb.gimp_context_pop()
        pdb.gimp_displays_flush
        disp1=pdb.gimp_display_new(image)
#################### end caramel ###########################
    if chocolate:
        pdb.gimp_context_push()
        black     ='#000000'
        white     ='#ffffff'
        image2 = pdb.gimp_image_new(1600,900,RGB)
        frozen2= pdb.gimp_image_undo_freeze(image2)
        background=gimp.Image.new_layer(image2)
        alpha=pdb.gimp_drawable_has_alpha(background)
        if not alpha:
            pdb.gimp_layer_add_alpha (background)
        background.name=('Background')
        pdb.gimp_context_set_background('#120a00')
        pdb.gimp_edit_fill(background,BACKGROUND_FILL) 
        gradientlay=gimp.Image.new_layer(image2)
        gradientlay.name='Layer'
        pdb.gimp_context_set_foreground('#652213')     #was('#432213')
        pdb.gimp_edit_blend(gradientlay,FG_TRANSPARENT_MODE,NORMAL_MODE,GRADIENT_RADIAL,100,0.0,REPEAT_NONE,False,False,1,0,True,800,0,800,900)
        pdb.gimp_context_set_foreground('#432213')     #  was('#d9b997')
        pdb.gimp_edit_blend(gradientlay,FG_TRANSPARENT_MODE,NORMAL_MODE,GRADIENT_RADIAL,100,0.0,REPEAT_NONE,False,False,1,0,True,800,0,800,700)
        background = pdb.gimp_image_flatten(image2)
        pdb.plug_in_gauss_rle2(image2, background,400,400)
        pdb.plug_in_gauss_rle2(image2, background,400,400)
####### get text
        chocolate = pdb.gimp_layer_new_from_drawable(inDrawable,image2) 
        image2.add_layer(chocolate)
        alpha=pdb.gimp_drawable_has_alpha(chocolate)
        if not alpha:
            pdb.gimp_layer_add_alpha (chocolate)
        chocolate.name = 'Chocolate'
        pdb.gimp_context_set_foreground('#590000')      # tried a bit light #5f1f00 was chocotext ='#201200'     
        pdb.gimp_image_select_item(image2,0,chocolate)
        pdb.gimp_edit_fill(chocolate,0)
        pdb.gimp_selection_none(image2)

        pdb.script_fu_layerfx_drop_shadow(image2,chocolate,black,75.0,0,0,2,0,9,130,5,1,0)
        pdb.script_fu_layerfx_bevel_emboss(image2,chocolate,1,65,0,9,16,130.0,45,5,'#533524',4,75,black,2,75,6,0,0)    
        pdb.script_fu_layerfx_gradient_overlay(image2, chocolate,'Chocolate #1',0,0,0,50.0,18,800,450,90,1000,0)
        chocolate2 = pdb.gimp_layer_copy(chocolate, 1)
        pdb.gimp_image_add_layer(image2,chocolate2,0)
        chocolate2.name='Chocolate copy'
        chocolate2.mode=NORMAL_MODE
        pdb.gimp_item_set_visible(chocolate2,False) 
        pdb.script_fu_layerfx_drop_shadow(image2,chocolate,black,45.0,0,0,2,0,14,130,8,1,0)
        pdb.script_fu_layerfx_bevel_emboss(image2,chocolate,1,65,0,18,5,130.0,45.0,3,white,4,100,'#291604',2,75,6,0,0) 
        visible = pdb.gimp_layer_new_from_visible(image2,image2,'visible')
        pdb.gimp_image_add_layer(image2,visible,0)
        if flatten:
            background.name=('Chocolate')
            pdb.gimp_image_flatten(image2)
        pdb.gimp_context_pop()
        pdb.gimp_displays_flush
        disp2=pdb.gimp_display_new(image2)
#################### end chocolate image2 ###########################
    if vanilla:
        pdb.gimp_context_push()
        black     ='#000000'        
        white     ='#ffffff'
        pdb.gimp_context_set_gradient('Vanilla')
        image3 = pdb.gimp_image_new(1600,900,RGB)
        frozen3= pdb.gimp_image_undo_freeze(image3)
        background=gimp.Image.new_layer(image3)
        alpha=pdb.gimp_drawable_has_alpha(background)
        if not alpha:
            pdb.gimp_layer_add_alpha (background)
        background.name=('Background')
        pdb.gimp_edit_blend(background,3,0,0,100,0.0,REPEAT_NONE,FALSE,False,1,0,True,800,900,800,0)
####### get text
        vanilla = pdb.gimp_layer_new_from_drawable(inDrawable,image3) 
        image3.add_layer(vanilla)
        alpha=pdb.gimp_drawable_has_alpha(vanilla)
        if not alpha:
            pdb.gimp_layer_add_alpha (vanilla)
        vanilla.name = 'Vanilla'
        pdb.gimp_context_set_foreground(black)      
        pdb.gimp_image_select_item(image3,0,vanilla)
        pdb.gimp_edit_fill(vanilla,0) 
        pdb.gimp_selection_none(image3)

        pdb.script_fu_layerfx_drop_shadow(image3,vanilla,'#c9c7be',75.0,0,0,2,10,17,60.0,14,1,0)
        pdb.script_fu_layerfx_inner_shadow(image3,vanilla,white,100,0,0,0,0,0,17,55,7,0)
        pdb.script_fu_layerfx_bevel_emboss(image3,vanilla,1,65,0,10,16,-110.0,20.0,0,'#fbef91',2,75.0,black,2,0.0,6,0,0)
        pdb.script_fu_layerfx_gradient_overlay(image3, vanilla,'Vanilla 2',0,0,0,100.0,0,800,450,90,300,0)

        # skipping this step - until find a way to do layerfx stroke with a gradient from the script.
        #tuple of (gradient_name1, gradient_type2, repeat3, reverse4, center_x5, center_y6, angle7, width 8)
        #gradient_name='Vanilla' gradient_type=0 repeat=0 reverse=0 center_x=800 center_y= 600 angle=90.0 width=500
        #tt=tuple('Vanilla' '0' '0' '0' '800' '600' '90.0' '500')  
        #pdb.python_layer_fx_stroke(image3,vanilla,tt,100.0,  0,     12,   100,   0)

        pdb.script_fu_layerfx_drop_shadow(image3,vanilla,'#c2c0b4',75.0,0,0,2,0,30,60.0,20,1,0)
        pdb.script_fu_layerfx_bevel_emboss(image3,vanilla,1,65,0,7,16,90.0,60.0,0,'#ffffff',0,100.0,'#f8f8f8',6,100.0,6,0,0)
        visible = pdb.gimp_layer_new_from_visible(image3,image3,'visible')
        pdb.gimp_image_add_layer(image3,visible,0)
        if flatten:
            background.name=('Vanilla')
            pdb.gimp_image_flatten(image3)
        pdb.gimp_context_pop()
        pdb.gimp_displays_flush
        disp2=pdb.gimp_display_new(image3)
#################### end vanilla image3 ###########################
 
    pdb.gimp_displays_flush
    return() 

register(
    "BA_Conbagui_CaramelChocolateVanillaText",    
    "Script Based On Conbagui's GoldBar Tutorial",   
    "Requirments show at top",
    "animicule@gimpchat.com", 
    "Brian Andersen", 
    "July 2017",
    "BA_Conbagui Caramel Chocolate Vanilla Text", 
    "RGB*", 
   [
      (PF_IMAGE,   "inImage",    "Input image             ", None),
      (PF_DRAWABLE,"inDrawable", "Input drawable          ", None),
      (PF_BOOL,    "caramel",    "Caramel Text            ",False),
      (PF_BOOL,    "chocolate",  "Chocolate Text          ",False),
      (PF_BOOL,    "vanilla",    "Vanilla Text            ",False),
      (PF_BOOL,    "flatten",    "Flatten Images          ",True ),
    ], 
    [],
    BA_Conbagui_CaramelChocolateVanillaText,
    menu="<Image>/Brian/",
    )

main()
